import java.util.Iterator;

public abstract class Simulator {

    public static int NORTH=-1;
    public static int SOUTH=-2;
    public static int EAST=-3;
    public static int WEST=-4;
    
    public static int MOVE=-5;
    public static int PICK=-6;
    public static int DROP=-7;
    public static int NONE=-8;
    
    public static int NEW_ROBOT_POSITION=-9;
    public static int ROBOT_ACTION=-10;
    
    public abstract void requestPick(AwareRobot robot, int bid, int packageIds[]);
    public abstract void requestDrop(AwareRobot robot, int bid, int packageIds[]);
    public abstract void requestMove(AwareRobot robot, int bid, int direction);
    public abstract AwareRobot addPlayer(Genome g);
    public abstract Iterator players();
    public abstract void run();
    
}